<template>
  <div>
    <div class="navbar">
      <router-link :to="{ name: 'root' }" class="logo">MYSLinks</router-link>
      <mq-layout mq="md+">
        <div class="menu">
          <router-link :to="{ name: 'root' }" :class="pageIsActive('root')">New SLink</router-link>
          <router-link :to="{ name: 'short_links-index' }" :class="pageIsActive('short-links')">My SLinks</router-link>
          <button v-if="signedIn" class="btn btn-red logout-btn" @click="logout">Sign Out</button>
          <router-link v-else tag="button" :to="{ name: 'signIn' }" class="btn btn-blue login-btn">
            Sign In
          </router-link>
        </div>
      </mq-layout>
      <mq-layout :mq="['xs', 'sm']">
        <div class="menu">
          <a href="javascript:void(0)" @click="toggleMenu" class='active'><i class="fa fa-fw fa-bars"></i></a>
        </div>
      </mq-layout>
    </div>
    <transition name="slide">
      <div class="mobile-menu" v-if="menuToggled">
        <router-link :to="{ name: 'root' }" :class="pageIsActive('root')">New SLink</router-link>
        <router-link :to="{ name: 'short_links-index' }" :class="pageIsActive('short-links')">My SLinks</router-link>
        <router-link :to="{ name: 'signIn' }" class="btn btn-blue login-btn"/>
      </div>
    </transition>
  </div>
</template>

<script>
import { mapGetters } from 'vuex'

export default {
  data () {
    return {
      menuToggled: false
    }
  },
  computed: { ...mapGetters(['signedIn', 'activePage']) },
  methods: {
    pageIsActive (page) {
      if (this.activePage == page) {
        return 'active'
      } else {
        return ''
      }
    },
    toggleMenu () {
      this.menuToggled = !this.menuToggled
    },
    logout () {
      this.$store.dispatch('logout')
      this.$router.push({ name: 'root' })
    }
  }
}
</script>

<style lang='sass' scoped>
  .navbar
    background-color: slategrey
    color: white
    display: flex
    justify-content: space-between
    .logo
      margin: 10px
      font-size: 2em
      font-weight: bold
      color: white
      text-decoration: none
    .menu
      display: inline
      a
        align-self: center
        float: left
        display: block
        color: #f2f2f2
        text-align: center
        padding: 19px 20px
        text-decoration: none
        font-size: 17px
        &.active,&:hover
          background-color: #ddd;
          color: black;
    .login-btn,.logout-btn
      margin: 10px;
      text-align: right
      align-self: center
  .slide-enter, .slide-leave-to
    transform: scaleY(0)
  .mobile-menu
    transform-origin: top
    transition: transform .4s ease-in-out
    text-align: center
    background-color: slategrey
    padding-bottom: 10px
    a
      color: #f2f2f2
      display: block
      font-size: 17px
      padding: 10px
      text-decoration: none
      &.active,&:hover
        color: black
        background-color: #ddd
</style>
